SystemOrganization addCategory: #Rango!
SystemOrganization addCategory: #'Rango-Tests'!

Object subclass: #Rango
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango'!

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
end
 ^end.! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
end: anEnd
 end := anEnd! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/16/2012 19:58'!
equals: aRange
	^ self start = aRange start and: [ self end = aRange end.].! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/16/2012 20:03'!
includeArgument: anArgument

^ anArgument >= self start and: [anArgument <= self end]
! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/16/2012 20:05'!
includes: aRange

^ (self includeArgument: aRange start) and: [self includeArgument: aRange end].
! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/18/2012 10:15'!
overlaps: aRange

"Juro que anda... se me cago la otra imagen donde tenia hechos los tests y es una paja hacerlos de nuevo :P"

^(self includes: aRange) or:[ (self includeArgument: aRange start)
								or: [ (self includeArgument: aRange end ) ] 
							].! !

!Rango methodsFor: 'accessors' stamp: 'Paul 4/16/2012 22:00'!
size
"Devuelve el taman~o del Rango"

 ^end - start.! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:28'!
start
^start! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
start: aStart
 start := aStart! !

TestCase subclass: #RangoIncludes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!RangoIncludes methodsFor: 'tests' stamp: 'LucasGiudice 4/16/2012 20:21'!
setUp 

| rangoUno rangoDos rangoTres |
rangoUno:= Rango new.
rangoDos:= Rango new.
rangoTres := Rango new.

rangoUno start: 10; end: 100.

rangoDos start: 9; end: 50.

rangoTres start: 11; end: 30.
! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/16/2012 21:28'!
testIncludesDateAndTime
| inicio fin unRangoGrande otroRangoChico|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 30.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 00.

otroRangoChico := Rango new.
otroRangoChico start: inicio.
otroRangoChico end: fin.

self assert: ( unRangoGrande includes: otroRangoChico)
 
! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/16/2012 21:34'!
testIncludesDateAndTimeEquals
| inicio fin unRangoGrande otroRangoIgual|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

otroRangoIgual := Rango new.
otroRangoIgual start: inicio.
otroRangoIgual end: fin.

self assert: ( unRangoGrande includes: otroRangoIgual)
 
! !

!RangoIncludes methodsFor: 'tests' stamp: 'LucasGiudice 4/16/2012 20:22'!
testIncludesEnRangoNumerico
| unoIncluyeDos  rangoUno rangoDos|

rangoUno:= Rango new.
rangoDos:= Rango new.

rangoUno start: 10; end: 100.

rangoDos start: 11; end: 50.

unoIncluyeDos := rangoUno includes: rangoDos.
 
self assert:  unoIncluyeDos = true! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/16/2012 21:30'!
testNotIncludesDateAndTime
| inicio fin unRangoGrande otroRangoChico|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 30.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 33  minute: 00.

otroRangoChico := Rango new.
otroRangoChico start: inicio.
otroRangoChico end: fin.

self assert: ( unRangoGrande includes: otroRangoChico) not.
 
! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/16/2012 21:32'!
testNotIncludesDateAndTimeIntersection
| inicio fin unRangoGrande otroRangoChico|

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 15.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

unRangoGrande := Rango new.
unRangoGrande start: inicio.
unRangoGrande end: fin.

inicio := DateAndTime year: 2012 month: 04 day: 16 hour: 21  minute: 00.
fin := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 00.

otroRangoChico := Rango new.
otroRangoChico start: inicio.
otroRangoChico end: fin.

self assert: ( unRangoGrande includes: otroRangoChico) not.
 
! !

TestCase subclass: #RangoSize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!RangoSize methodsFor: 'tests' stamp: 'Paul 4/16/2012 22:14'!
testSizeDateAndTime
	"Prueba el metodo con los DateAndTime"

	| inicio fin unRango duracionEsperada |
	inicio := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 21
		minute: 0.
	fin := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 22
		minute: 0.
	unRango := Rango new.
	unRango start: inicio.
	unRango end: fin.
	duracionEsperada := Duration
		days: 0
		hours: 1
		minutes: 0
		seconds: 0.
	self assert: duracionEsperada equals: unRango size! !

!RangoSize methodsFor: 'tests' stamp: 'Paul 4/16/2012 22:14'!
testSizeNumerico
	"Prueba el metodo con los numeros"

	| inicio fin unRango |
	inicio := 1.
	fin := 3.
	unRango := Rango new.
	unRango start: inicio.
	unRango end: fin.
	self assert: 2 equals: unRango size! !
